package com.yami.shop.service.impl;

import com.aliyun.oss.ServiceException;
import com.yami.shop.bean.model.SysDictData;
import com.yami.shop.bean.model.SysDictType;
import com.yami.shop.common.exception.GlobalException;
import com.yami.shop.dao.SysDictDataMapper;
import com.yami.shop.dao.SysDictTypeMapper;
import com.yami.shop.service.ISysDictTypeService;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.PostConstruct;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 字典 业务层处理
 *
 * @author ruoyi
 */
@Service
public class SysDictTypeServiceImpl implements ISysDictTypeService
{
    @Autowired
    private SysDictTypeMapper dictTypeMapper;

    @Autowired
    private SysDictDataMapper dictDataMapper;

//    /**
//     * 项目启动时，初始化字典到缓存
//     */
//    @PostConstruct
//    public void init()
//    {
//        loadingDictCache();
//    }

    /**
     * 根据条件分页查询字典类型
     *
     * @param dictType 字典类型信息
     * @return 字典类型集合信息
     */
    @Override
    public List<SysDictType> selectDictTypeList(SysDictType dictType)
    {
        return dictTypeMapper.selectDictTypeList(dictType);
    }

    /**
     * 根据所有字典类型
     *
     * @return 字典类型集合信息
     */
    @Override
    public List<SysDictType> selectDictTypeAll()
    {
        return dictTypeMapper.selectDictTypeAll();
    }

    /**
     * 根据字典类型查询字典数据
     *
     * @param dictType 字典类型
     * @return 字典数据集合信息
     */
    @Override
    public List<SysDictData> selectDictDataByType(String dictType)
    {
        List<SysDictData> dictDatas = dictDataMapper.selectDictDataByType(dictType);
        if (ObjectUtils.isNotEmpty(dictDatas))
        {
            return dictDatas;
        }
        return null;
    }

    /**
     * 根据字典类型ID查询信息
     *
     * @param dictId 字典类型ID
     * @return 字典类型
     */
    @Override
    public SysDictType selectDictTypeById(Long dictId)
    {
        return dictTypeMapper.selectDictTypeById(dictId);
    }

    /**
     * 根据字典类型查询信息
     *
     * @param dictType 字典类型
     * @return 字典类型
     */
    @Override
    public SysDictType selectDictTypeByType(String dictType)
    {
        return dictTypeMapper.selectDictTypeByType(dictType);
    }

    /**
     * 批量删除字典类型信息
     *
     * @param dictIds 需要删除的字典ID
     */
    @Override
    public void deleteDictTypeByIds(Long[] dictIds)
    {
        for (Long dictId : dictIds)
        {
            SysDictType dictType = selectDictTypeById(dictId);
            if (dictType!=null){
                if (0==dictType.getStatus()){
                    if (dictDataMapper.countDictDataByType(dictType.getDictType()) > 0)
                    {
                        throw new GlobalException(String.format("%1$s已分配,不能删除", dictType.getDictName()));
                    }
                }
                dictTypeMapper.deleteDictTypeById(dictId);
                dictDataMapper.deleteDictDataByDictType(dictType.getDictType());
            }

        }
    }


    /**
     * 新增保存字典类型信息
     *
     * @param dict 字典类型信息
     * @return 结果
     */
    @Override
    public int insertDictType(SysDictType dict)
    {
        int row = dictTypeMapper.insertDictType(dict);
        return row;
    }

    /**
     * 修改保存字典类型信息
     *
     * @param dict 字典类型信息
     * @return 结果
     */
    @Override
    @Transactional
    public int updateDictType(SysDictType dict)
    {
        SysDictType oldDict = dictTypeMapper.selectDictTypeById(dict.getDictId());
        if (dict!=null&&oldDict!=null){
            dictDataMapper.updateDictDataType(oldDict.getDictType(), dict.getDictType());
            return dictTypeMapper.updateDictType(dict);
        }
        return 0;
    }

    /**
     * 校验字典类型称是否唯一
     *
     * @param dict 字典类型
     * @return 结果
     */
    @Override
    public boolean checkDictTypeUnique(SysDictType dict)
    {
        Long dictId = ObjectUtils.isEmpty(dict.getDictId()) ? -1L : dict.getDictId();
        SysDictType dictType = dictTypeMapper.checkDictTypeUnique(dict.getDictType());
        if (ObjectUtils.isNotEmpty(dictType) && dictType.getDictId().longValue() != dictId.longValue())
        {
            return false;
        }
        return true;
    }
}
